# coding: utf-8

"""
    Compass API

      #### Welcome to the DeFi API from [Compass Labs](https://www.compasslabs.ai)!  Our API allows you to interact and transact in DeFi with ease.  We help you construct your transactions via a **simple REST API**.   You maintain custody at all times and **sign** all transactions **yourself**.  Below is the documentation of our endpoints. It's a great first step to explore.  

    The version of the OpenAPI document: 0.0.1
    Contact: contact@compasslabs.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from compass.api_client.models.base_transaction_request_aerodrome_liquidity_provision_call_data import BaseTransactionRequestAerodromeLiquidityProvisionCallData
from compass.api_client.models.base_transaction_request_aerodrome_liquidity_provision_eth_call_data import BaseTransactionRequestAerodromeLiquidityProvisionEthCallData
from compass.api_client.models.base_transaction_request_aerodrome_remove_liquidity_call_data import BaseTransactionRequestAerodromeRemoveLiquidityCallData
from compass.api_client.models.base_transaction_request_aerodrome_remove_liquidity_eth_call_data import BaseTransactionRequestAerodromeRemoveLiquidityEthCallData
from compass.api_client.models.base_transaction_request_aerodrome_swap_eth_for_token_call_data import BaseTransactionRequestAerodromeSwapEthForTokenCallData
from compass.api_client.models.base_transaction_request_aerodrome_swap_token_for_eth_call_data import BaseTransactionRequestAerodromeSwapTokenForEthCallData
from compass.api_client.models.base_transaction_request_aerodrome_swap_tokens_call_data import BaseTransactionRequestAerodromeSwapTokensCallData
from compass.api_client.models.unsigned_transaction import UnsignedTransaction

from compass.api_client.api_client import ApiClient, RequestSerialized
from compass.api_client.api_response import ApiResponse
from compass.api_client.rest import RESTResponseType


class AerodromeBasicApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_eth_post(
        self,
        base_transaction_request_aerodrome_liquidity_provision_eth_call_data: BaseTransactionRequestAerodromeLiquidityProvisionEthCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> UnsignedTransaction:
        """Provide liquidity to a pool on Aerodrome using WETH and another token

        This endpoint allows users to provide liquidity to a specified pool on the         Aerodrome platform using Wrapped Ether (WETH) and another token. Users must         specify the token pair, desired amounts, minimum amounts, and a deadline for         the transaction. The operation will ensure the pool exists and will use the         sender's address if no recipient is specified. The transaction will be executed         through the Aerodrome Basic Router contract, and the specified amount of WETH         will be sent along with the transaction.

        :param base_transaction_request_aerodrome_liquidity_provision_eth_call_data: (required)
        :type base_transaction_request_aerodrome_liquidity_provision_eth_call_data: BaseTransactionRequestAerodromeLiquidityProvisionEthCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_eth_post_serialize(
            base_transaction_request_aerodrome_liquidity_provision_eth_call_data=base_transaction_request_aerodrome_liquidity_provision_eth_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_eth_post_with_http_info(
        self,
        base_transaction_request_aerodrome_liquidity_provision_eth_call_data: BaseTransactionRequestAerodromeLiquidityProvisionEthCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[UnsignedTransaction]:
        """Provide liquidity to a pool on Aerodrome using WETH and another token

        This endpoint allows users to provide liquidity to a specified pool on the         Aerodrome platform using Wrapped Ether (WETH) and another token. Users must         specify the token pair, desired amounts, minimum amounts, and a deadline for         the transaction. The operation will ensure the pool exists and will use the         sender's address if no recipient is specified. The transaction will be executed         through the Aerodrome Basic Router contract, and the specified amount of WETH         will be sent along with the transaction.

        :param base_transaction_request_aerodrome_liquidity_provision_eth_call_data: (required)
        :type base_transaction_request_aerodrome_liquidity_provision_eth_call_data: BaseTransactionRequestAerodromeLiquidityProvisionEthCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_eth_post_serialize(
            base_transaction_request_aerodrome_liquidity_provision_eth_call_data=base_transaction_request_aerodrome_liquidity_provision_eth_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_eth_post_without_preload_content(
        self,
        base_transaction_request_aerodrome_liquidity_provision_eth_call_data: BaseTransactionRequestAerodromeLiquidityProvisionEthCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Provide liquidity to a pool on Aerodrome using WETH and another token

        This endpoint allows users to provide liquidity to a specified pool on the         Aerodrome platform using Wrapped Ether (WETH) and another token. Users must         specify the token pair, desired amounts, minimum amounts, and a deadline for         the transaction. The operation will ensure the pool exists and will use the         sender's address if no recipient is specified. The transaction will be executed         through the Aerodrome Basic Router contract, and the specified amount of WETH         will be sent along with the transaction.

        :param base_transaction_request_aerodrome_liquidity_provision_eth_call_data: (required)
        :type base_transaction_request_aerodrome_liquidity_provision_eth_call_data: BaseTransactionRequestAerodromeLiquidityProvisionEthCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_eth_post_serialize(
            base_transaction_request_aerodrome_liquidity_provision_eth_call_data=base_transaction_request_aerodrome_liquidity_provision_eth_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_eth_post_serialize(
        self,
        base_transaction_request_aerodrome_liquidity_provision_eth_call_data,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if base_transaction_request_aerodrome_liquidity_provision_eth_call_data is not None:
            _body_params = base_transaction_request_aerodrome_liquidity_provision_eth_call_data


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/v0/aerodrome_basic/liquidity_provision/add_liquidity_eth',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_post(
        self,
        base_transaction_request_aerodrome_liquidity_provision_call_data: BaseTransactionRequestAerodromeLiquidityProvisionCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> UnsignedTransaction:
        """Provide liquidity to a pool on Aerodrome

        This endpoint allows users to provide liquidity to a specified pool on the         Aerodrome platform. Users must specify the tokens, desired amounts, minimum         amounts, and a deadline for the transaction. The operation will ensure the         pool exists and will use the sender's address if no recipient is specified.

        :param base_transaction_request_aerodrome_liquidity_provision_call_data: (required)
        :type base_transaction_request_aerodrome_liquidity_provision_call_data: BaseTransactionRequestAerodromeLiquidityProvisionCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_post_serialize(
            base_transaction_request_aerodrome_liquidity_provision_call_data=base_transaction_request_aerodrome_liquidity_provision_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_post_with_http_info(
        self,
        base_transaction_request_aerodrome_liquidity_provision_call_data: BaseTransactionRequestAerodromeLiquidityProvisionCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[UnsignedTransaction]:
        """Provide liquidity to a pool on Aerodrome

        This endpoint allows users to provide liquidity to a specified pool on the         Aerodrome platform. Users must specify the tokens, desired amounts, minimum         amounts, and a deadline for the transaction. The operation will ensure the         pool exists and will use the sender's address if no recipient is specified.

        :param base_transaction_request_aerodrome_liquidity_provision_call_data: (required)
        :type base_transaction_request_aerodrome_liquidity_provision_call_data: BaseTransactionRequestAerodromeLiquidityProvisionCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_post_serialize(
            base_transaction_request_aerodrome_liquidity_provision_call_data=base_transaction_request_aerodrome_liquidity_provision_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_post_without_preload_content(
        self,
        base_transaction_request_aerodrome_liquidity_provision_call_data: BaseTransactionRequestAerodromeLiquidityProvisionCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Provide liquidity to a pool on Aerodrome

        This endpoint allows users to provide liquidity to a specified pool on the         Aerodrome platform. Users must specify the tokens, desired amounts, minimum         amounts, and a deadline for the transaction. The operation will ensure the         pool exists and will use the sender's address if no recipient is specified.

        :param base_transaction_request_aerodrome_liquidity_provision_call_data: (required)
        :type base_transaction_request_aerodrome_liquidity_provision_call_data: BaseTransactionRequestAerodromeLiquidityProvisionCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_post_serialize(
            base_transaction_request_aerodrome_liquidity_provision_call_data=base_transaction_request_aerodrome_liquidity_provision_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _process_request_v0_aerodrome_basic_liquidity_provision_add_liquidity_post_serialize(
        self,
        base_transaction_request_aerodrome_liquidity_provision_call_data,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if base_transaction_request_aerodrome_liquidity_provision_call_data is not None:
            _body_params = base_transaction_request_aerodrome_liquidity_provision_call_data


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/v0/aerodrome_basic/liquidity_provision/add_liquidity',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_eth_post(
        self,
        base_transaction_request_aerodrome_remove_liquidity_eth_call_data: BaseTransactionRequestAerodromeRemoveLiquidityEthCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> UnsignedTransaction:
        """Remove liquidity from a pool on Aerodrome using WETH and another token

        This endpoint allows users to remove liquidity from a pool on the Aerodrome         platform using WETH and another token. Users must specify the token pair, the         amount of liquidity to remove, minimum amounts for each token, and a deadline         for the transaction. The operation will ensure the pool exists and will use         the sender's address if no recipient is specified. The transaction will be         executed through the Aerodrome Basic Router contract, and the specified amount         of liquidity will be withdrawn from the pool.

        :param base_transaction_request_aerodrome_remove_liquidity_eth_call_data: (required)
        :type base_transaction_request_aerodrome_remove_liquidity_eth_call_data: BaseTransactionRequestAerodromeRemoveLiquidityEthCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_eth_post_serialize(
            base_transaction_request_aerodrome_remove_liquidity_eth_call_data=base_transaction_request_aerodrome_remove_liquidity_eth_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_eth_post_with_http_info(
        self,
        base_transaction_request_aerodrome_remove_liquidity_eth_call_data: BaseTransactionRequestAerodromeRemoveLiquidityEthCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[UnsignedTransaction]:
        """Remove liquidity from a pool on Aerodrome using WETH and another token

        This endpoint allows users to remove liquidity from a pool on the Aerodrome         platform using WETH and another token. Users must specify the token pair, the         amount of liquidity to remove, minimum amounts for each token, and a deadline         for the transaction. The operation will ensure the pool exists and will use         the sender's address if no recipient is specified. The transaction will be         executed through the Aerodrome Basic Router contract, and the specified amount         of liquidity will be withdrawn from the pool.

        :param base_transaction_request_aerodrome_remove_liquidity_eth_call_data: (required)
        :type base_transaction_request_aerodrome_remove_liquidity_eth_call_data: BaseTransactionRequestAerodromeRemoveLiquidityEthCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_eth_post_serialize(
            base_transaction_request_aerodrome_remove_liquidity_eth_call_data=base_transaction_request_aerodrome_remove_liquidity_eth_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_eth_post_without_preload_content(
        self,
        base_transaction_request_aerodrome_remove_liquidity_eth_call_data: BaseTransactionRequestAerodromeRemoveLiquidityEthCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Remove liquidity from a pool on Aerodrome using WETH and another token

        This endpoint allows users to remove liquidity from a pool on the Aerodrome         platform using WETH and another token. Users must specify the token pair, the         amount of liquidity to remove, minimum amounts for each token, and a deadline         for the transaction. The operation will ensure the pool exists and will use         the sender's address if no recipient is specified. The transaction will be         executed through the Aerodrome Basic Router contract, and the specified amount         of liquidity will be withdrawn from the pool.

        :param base_transaction_request_aerodrome_remove_liquidity_eth_call_data: (required)
        :type base_transaction_request_aerodrome_remove_liquidity_eth_call_data: BaseTransactionRequestAerodromeRemoveLiquidityEthCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_eth_post_serialize(
            base_transaction_request_aerodrome_remove_liquidity_eth_call_data=base_transaction_request_aerodrome_remove_liquidity_eth_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_eth_post_serialize(
        self,
        base_transaction_request_aerodrome_remove_liquidity_eth_call_data,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if base_transaction_request_aerodrome_remove_liquidity_eth_call_data is not None:
            _body_params = base_transaction_request_aerodrome_remove_liquidity_eth_call_data


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/v0/aerodrome_basic/liquidity_provision/remove_liquidity_eth',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_post(
        self,
        base_transaction_request_aerodrome_remove_liquidity_call_data: BaseTransactionRequestAerodromeRemoveLiquidityCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> UnsignedTransaction:
        """Remove liquidity from a pool on Aerodrome

        This endpoint allows users to remove liquidity from a specified pool on the         Aerodrome platform. Users must specify the token pair, the amount of liquidity         to remove, minimum amounts for each token, and a deadline for the transaction.         The operation will ensure the pool exists and will use the sender's address if         no recipient is specified. The transaction will be executed through the         Aerodrome Basic Router contract, and the specified amount of liquidity will be         withdrawn from the pool.

        :param base_transaction_request_aerodrome_remove_liquidity_call_data: (required)
        :type base_transaction_request_aerodrome_remove_liquidity_call_data: BaseTransactionRequestAerodromeRemoveLiquidityCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_post_serialize(
            base_transaction_request_aerodrome_remove_liquidity_call_data=base_transaction_request_aerodrome_remove_liquidity_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_post_with_http_info(
        self,
        base_transaction_request_aerodrome_remove_liquidity_call_data: BaseTransactionRequestAerodromeRemoveLiquidityCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[UnsignedTransaction]:
        """Remove liquidity from a pool on Aerodrome

        This endpoint allows users to remove liquidity from a specified pool on the         Aerodrome platform. Users must specify the token pair, the amount of liquidity         to remove, minimum amounts for each token, and a deadline for the transaction.         The operation will ensure the pool exists and will use the sender's address if         no recipient is specified. The transaction will be executed through the         Aerodrome Basic Router contract, and the specified amount of liquidity will be         withdrawn from the pool.

        :param base_transaction_request_aerodrome_remove_liquidity_call_data: (required)
        :type base_transaction_request_aerodrome_remove_liquidity_call_data: BaseTransactionRequestAerodromeRemoveLiquidityCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_post_serialize(
            base_transaction_request_aerodrome_remove_liquidity_call_data=base_transaction_request_aerodrome_remove_liquidity_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_post_without_preload_content(
        self,
        base_transaction_request_aerodrome_remove_liquidity_call_data: BaseTransactionRequestAerodromeRemoveLiquidityCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Remove liquidity from a pool on Aerodrome

        This endpoint allows users to remove liquidity from a specified pool on the         Aerodrome platform. Users must specify the token pair, the amount of liquidity         to remove, minimum amounts for each token, and a deadline for the transaction.         The operation will ensure the pool exists and will use the sender's address if         no recipient is specified. The transaction will be executed through the         Aerodrome Basic Router contract, and the specified amount of liquidity will be         withdrawn from the pool.

        :param base_transaction_request_aerodrome_remove_liquidity_call_data: (required)
        :type base_transaction_request_aerodrome_remove_liquidity_call_data: BaseTransactionRequestAerodromeRemoveLiquidityCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_post_serialize(
            base_transaction_request_aerodrome_remove_liquidity_call_data=base_transaction_request_aerodrome_remove_liquidity_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _process_request_v0_aerodrome_basic_liquidity_provision_remove_liquidity_post_serialize(
        self,
        base_transaction_request_aerodrome_remove_liquidity_call_data,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if base_transaction_request_aerodrome_remove_liquidity_call_data is not None:
            _body_params = base_transaction_request_aerodrome_remove_liquidity_call_data


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/v0/aerodrome_basic/liquidity_provision/remove_liquidity',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def process_request_v0_aerodrome_basic_swap_eth_for_token_post(
        self,
        base_transaction_request_aerodrome_swap_eth_for_token_call_data: BaseTransactionRequestAerodromeSwapEthForTokenCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> UnsignedTransaction:
        """Swap ETH for some of a token on Aerodrome

        This endpoint allows you to swap a specified amount of ETH for a         desired token on the Aerodrome platform. To protect against         unfavorable exchange rates, you must specify the minimum amount         of the token you wish to receive. The transaction will only be         executed if this minimum amount is met, ensuring you do not         accidentally trade at a disadvantageous rate.

        :param base_transaction_request_aerodrome_swap_eth_for_token_call_data: (required)
        :type base_transaction_request_aerodrome_swap_eth_for_token_call_data: BaseTransactionRequestAerodromeSwapEthForTokenCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_swap_eth_for_token_post_serialize(
            base_transaction_request_aerodrome_swap_eth_for_token_call_data=base_transaction_request_aerodrome_swap_eth_for_token_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def process_request_v0_aerodrome_basic_swap_eth_for_token_post_with_http_info(
        self,
        base_transaction_request_aerodrome_swap_eth_for_token_call_data: BaseTransactionRequestAerodromeSwapEthForTokenCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[UnsignedTransaction]:
        """Swap ETH for some of a token on Aerodrome

        This endpoint allows you to swap a specified amount of ETH for a         desired token on the Aerodrome platform. To protect against         unfavorable exchange rates, you must specify the minimum amount         of the token you wish to receive. The transaction will only be         executed if this minimum amount is met, ensuring you do not         accidentally trade at a disadvantageous rate.

        :param base_transaction_request_aerodrome_swap_eth_for_token_call_data: (required)
        :type base_transaction_request_aerodrome_swap_eth_for_token_call_data: BaseTransactionRequestAerodromeSwapEthForTokenCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_swap_eth_for_token_post_serialize(
            base_transaction_request_aerodrome_swap_eth_for_token_call_data=base_transaction_request_aerodrome_swap_eth_for_token_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def process_request_v0_aerodrome_basic_swap_eth_for_token_post_without_preload_content(
        self,
        base_transaction_request_aerodrome_swap_eth_for_token_call_data: BaseTransactionRequestAerodromeSwapEthForTokenCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Swap ETH for some of a token on Aerodrome

        This endpoint allows you to swap a specified amount of ETH for a         desired token on the Aerodrome platform. To protect against         unfavorable exchange rates, you must specify the minimum amount         of the token you wish to receive. The transaction will only be         executed if this minimum amount is met, ensuring you do not         accidentally trade at a disadvantageous rate.

        :param base_transaction_request_aerodrome_swap_eth_for_token_call_data: (required)
        :type base_transaction_request_aerodrome_swap_eth_for_token_call_data: BaseTransactionRequestAerodromeSwapEthForTokenCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_swap_eth_for_token_post_serialize(
            base_transaction_request_aerodrome_swap_eth_for_token_call_data=base_transaction_request_aerodrome_swap_eth_for_token_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _process_request_v0_aerodrome_basic_swap_eth_for_token_post_serialize(
        self,
        base_transaction_request_aerodrome_swap_eth_for_token_call_data,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if base_transaction_request_aerodrome_swap_eth_for_token_call_data is not None:
            _body_params = base_transaction_request_aerodrome_swap_eth_for_token_call_data


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/v0/aerodrome_basic/swap/eth_for_token',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def process_request_v0_aerodrome_basic_swap_token_for_eth_post(
        self,
        base_transaction_request_aerodrome_swap_token_for_eth_call_data: BaseTransactionRequestAerodromeSwapTokenForEthCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> UnsignedTransaction:
        """Swap a token for ETH on Aerodrome

        Swap a specified amount of a token for ETH using the Aerodrome platform.         To protect against unfavorable exchange rates, you must specify the minimum         amount of ETH you wish to receive. The transaction will only be executed if         this minimum amount is met, ensuring you do not trade at a disadvantageous rate.

        :param base_transaction_request_aerodrome_swap_token_for_eth_call_data: (required)
        :type base_transaction_request_aerodrome_swap_token_for_eth_call_data: BaseTransactionRequestAerodromeSwapTokenForEthCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_swap_token_for_eth_post_serialize(
            base_transaction_request_aerodrome_swap_token_for_eth_call_data=base_transaction_request_aerodrome_swap_token_for_eth_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def process_request_v0_aerodrome_basic_swap_token_for_eth_post_with_http_info(
        self,
        base_transaction_request_aerodrome_swap_token_for_eth_call_data: BaseTransactionRequestAerodromeSwapTokenForEthCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[UnsignedTransaction]:
        """Swap a token for ETH on Aerodrome

        Swap a specified amount of a token for ETH using the Aerodrome platform.         To protect against unfavorable exchange rates, you must specify the minimum         amount of ETH you wish to receive. The transaction will only be executed if         this minimum amount is met, ensuring you do not trade at a disadvantageous rate.

        :param base_transaction_request_aerodrome_swap_token_for_eth_call_data: (required)
        :type base_transaction_request_aerodrome_swap_token_for_eth_call_data: BaseTransactionRequestAerodromeSwapTokenForEthCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_swap_token_for_eth_post_serialize(
            base_transaction_request_aerodrome_swap_token_for_eth_call_data=base_transaction_request_aerodrome_swap_token_for_eth_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def process_request_v0_aerodrome_basic_swap_token_for_eth_post_without_preload_content(
        self,
        base_transaction_request_aerodrome_swap_token_for_eth_call_data: BaseTransactionRequestAerodromeSwapTokenForEthCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Swap a token for ETH on Aerodrome

        Swap a specified amount of a token for ETH using the Aerodrome platform.         To protect against unfavorable exchange rates, you must specify the minimum         amount of ETH you wish to receive. The transaction will only be executed if         this minimum amount is met, ensuring you do not trade at a disadvantageous rate.

        :param base_transaction_request_aerodrome_swap_token_for_eth_call_data: (required)
        :type base_transaction_request_aerodrome_swap_token_for_eth_call_data: BaseTransactionRequestAerodromeSwapTokenForEthCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_swap_token_for_eth_post_serialize(
            base_transaction_request_aerodrome_swap_token_for_eth_call_data=base_transaction_request_aerodrome_swap_token_for_eth_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _process_request_v0_aerodrome_basic_swap_token_for_eth_post_serialize(
        self,
        base_transaction_request_aerodrome_swap_token_for_eth_call_data,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if base_transaction_request_aerodrome_swap_token_for_eth_call_data is not None:
            _body_params = base_transaction_request_aerodrome_swap_token_for_eth_call_data


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/v0/aerodrome_basic/swap/token_for_eth',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def process_request_v0_aerodrome_basic_swap_tokens_post(
        self,
        base_transaction_request_aerodrome_swap_tokens_call_data: BaseTransactionRequestAerodromeSwapTokensCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> UnsignedTransaction:
        """Swap one token for another token on Aerodrome

        Swap one token for another on Aerodrome.         Ensure you specify the minimum amount you expect to receive to         avoid trading at an unfavorable exchange rate. This endpoint         facilitates the exchange of tokens by interacting with the         Aerodrome smart contract, ensuring that the transaction is         executed only if the specified minimum output is met.

        :param base_transaction_request_aerodrome_swap_tokens_call_data: (required)
        :type base_transaction_request_aerodrome_swap_tokens_call_data: BaseTransactionRequestAerodromeSwapTokensCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_swap_tokens_post_serialize(
            base_transaction_request_aerodrome_swap_tokens_call_data=base_transaction_request_aerodrome_swap_tokens_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def process_request_v0_aerodrome_basic_swap_tokens_post_with_http_info(
        self,
        base_transaction_request_aerodrome_swap_tokens_call_data: BaseTransactionRequestAerodromeSwapTokensCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[UnsignedTransaction]:
        """Swap one token for another token on Aerodrome

        Swap one token for another on Aerodrome.         Ensure you specify the minimum amount you expect to receive to         avoid trading at an unfavorable exchange rate. This endpoint         facilitates the exchange of tokens by interacting with the         Aerodrome smart contract, ensuring that the transaction is         executed only if the specified minimum output is met.

        :param base_transaction_request_aerodrome_swap_tokens_call_data: (required)
        :type base_transaction_request_aerodrome_swap_tokens_call_data: BaseTransactionRequestAerodromeSwapTokensCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_swap_tokens_post_serialize(
            base_transaction_request_aerodrome_swap_tokens_call_data=base_transaction_request_aerodrome_swap_tokens_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def process_request_v0_aerodrome_basic_swap_tokens_post_without_preload_content(
        self,
        base_transaction_request_aerodrome_swap_tokens_call_data: BaseTransactionRequestAerodromeSwapTokensCallData,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Swap one token for another token on Aerodrome

        Swap one token for another on Aerodrome.         Ensure you specify the minimum amount you expect to receive to         avoid trading at an unfavorable exchange rate. This endpoint         facilitates the exchange of tokens by interacting with the         Aerodrome smart contract, ensuring that the transaction is         executed only if the specified minimum output is met.

        :param base_transaction_request_aerodrome_swap_tokens_call_data: (required)
        :type base_transaction_request_aerodrome_swap_tokens_call_data: BaseTransactionRequestAerodromeSwapTokensCallData
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._process_request_v0_aerodrome_basic_swap_tokens_post_serialize(
            base_transaction_request_aerodrome_swap_tokens_call_data=base_transaction_request_aerodrome_swap_tokens_call_data,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UnsignedTransaction",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _process_request_v0_aerodrome_basic_swap_tokens_post_serialize(
        self,
        base_transaction_request_aerodrome_swap_tokens_call_data,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if base_transaction_request_aerodrome_swap_tokens_call_data is not None:
            _body_params = base_transaction_request_aerodrome_swap_tokens_call_data


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/v0/aerodrome_basic/swap/tokens',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


